\name {HTML_input}
\class {field}
\security {1}
\script	{
	switch (arg[0]) {
	case 'i':
		new = send(self(), "clone");
		if (defaultRows == 0) defaultRows = 1;
		if (inputObj == 0) inputObj = "HTML_input_str";

		/* inlined objects don't instantiate clones and have
		 * the clone inserted in the holding object's children list
		 * as usual objects do. So, need to tell parent to adopt
		 * the clone that is created here ... don't work. b/c not
		 * all parents are created then...
		 */
		/*send(parent(), "adopt", new);*/

		send(new, "make", inputObj, tagID, defaultVal, 
			defaultRows, objWidth, isRadio, checked);
		t = concat("\\o(", new, ")");

		/* reset defaults */
		inputObj = "HTML_input_str";
		defaultVal = "";
		defaultRows = 1;
		objWidth = 300;
		isRadio = 0;
		checked = 0;

		return t;
	break;
	case "make":
		inputObj = arg[1];
		tagID = arg[2];
		defaultVal = arg[3];
		defaultRows = arg[4];
		isRadio = arg[6];
		checked = arg[7];

		set("width", arg[5]);

/*		tagPtr = STG_tagPtr("INPUT");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}
*/
		if (defaultVal == 0) defaultVal = "";/* could be a bad idea*/
		if (checked) defaultVal = 1;

		if (inputObj == -1) return 0; /* ignore */
		if (inputObj == 0) inputObj = "HTML_input_str";

		new = send(inputObj, "clone");
		objectListAppend_children(new);
		h = send(new, "make", self(), defaultVal,
			get("width") - 2, defaultRows * 18 - 2, checked) + 2;
		if (h == 0) return 1;
		set("height", h);

		if (form == 0) form = send(parent(), "findForm");
		if (form == 0) {
			print("HTML_input: can't find form. self=",
				self(), "\n");
		} else {
			if (inputObj != "HTML_input_submit" &&
			    inputObj != "HTML_input_reset")
				send(form, "regInputer", self());
		}
		if (isRadio) {
			send(form, "radioReg", tagID, self());
		}
		if (checked) {
			send(nthChild(0), "buttonPress");
			send(nthChild(0), "buttonRelease");
		}
		return h + 2;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 * arg[3]	height
		 */
		if (style_p == 0) style_p = SGMLGetStyle("HTML", "INPUT");
		vspan = style_p[0];
		set("y", arg[1] + vspan);
		ww = arg[2] - get("x") - style_p[3];
		set("width", ww);
		h = send(nthChild(0), 'R', arg[1], ww - 2);
		return vspan + set("height", h) + style_p[1];
	break;
	case 'r':
		set("width", get("width") - 10);
		h = send(nthChild(0), 'R', 0, get("width")) + 2;
		set("height", h);
		return h + 2;
	break;
	case "AI":
		switch (arg[1]) {
		case "TYPE":
			inputObj = "HTML_input_str";
		break;
		case "VALUE":
			defaultVal = "";
		break;
		case "SIZE":
			defaultRows = 1;
			set("height", 19);
		break;
		}
		return;
	break;
	case "AA":
		switch (arg[1]) {
		case "TYPE":
			inputType = arg[1];
			switch (arg[2]) {
			case "int":
				inputObj = "HTML_input_int";
				objWidth = 50;
			break;
			case "percent":
				inputObj = "HTML_input_percent";
				objWidth = 300;
			break;
			case "boolean":
			case "check":
			case "checkbox":
				inputObj = "HTML_input_check";
				objWidth = 18;
			break;
			case "radio":
				inputObj = "HTML_input_radio";
				isRadio = 1;
				objWidth = 18;
			break;
			case "doodle":
				inputObj = "HTML_input_doodle";
				isRadio = 1;
				objWidth = 300;
			break;
			case "text":/* multiline*/
				inputObj = "HTML_input_text";
				objWidth = 300;
			break;
			case "submit":
				inputObj = "HTML_input_submit";
				objWidth = 100;
				defaultRows = 2;
			break;
			case "reset":
				inputObj = "HTML_input_reset";
				objWidth = 100;
				defaultRows = 2;
			break;
			case "str":
			default:
				inputObj = "HTML_input_str";
				objWidth = 300;
			break;
			}
		break;
		case "ID":
		case "NAME":
			tagID = arg[2];
		break;
		case "VALUE":
			defaultVal = arg[2];
		break;
		case "ENVVAR":
			defaultVal = environVar(arg[2]);
		break;
		case "SIZE":
			i = findPattern(arg[2], ',');
			if (i == -1) {
				/* just col info, ignore */
			} else {
				defaultRows = int(nthChar(arg[2], i + 1, 99));
				set("height", defaultRows * 15);
			}
		break;
		case "CHECKED":
			checked = 1;
		break;
		case "MINCHARS":
			minChars = arg[2];
		break;
		case "MAXCHARS":
			maxChars = arg[2];
		break;
		case "CHARS":
			maxChars = minChars = arg[2];
		break;
		case "MAXWIDTH":
			set("maxWidth", arg[2]);
		break;
		case "MINWIDTH":
			set("minWidth", arg[2]);
		break;
		}
		return;
	break;
	case "value":
		return concat(HTTPEncodeURL(tagID), "=",
				HTTPEncodeURL(send(nthChild(0), "value")));
	break;
	case "reset":
		return send(nthChild(0), "reset");
	break;
	case "radioOnReq":
		/* tell form that this radio button wants to be ON */
		return send(form, "radioOnReq", tagID, self());
	break;
	case "radioOff":
		/* form calls back to tell this radio button to be OFF*/
		send(nthChild(0), "toggleTo", 0);
		return;
	break;
	case "radioOn":
		/* form calls back to say that this radio button can be ON */
		send(nthChild(0), "toggleTo", 1);
		return;
	break;
	case "acceptForm":
	case "resetForm":
		return send(form, arg[0]);
	break;
	case "minChars?":
		return minChars;
	break;
	case "maxChars?":
		return maxChars;
	break;
	case "regInput":
		return send(form, arg[0], arg[1]);
	break;
	case "outputSGML":
		print("<INPUT");
		if (tagID) print(" NAME=\"", tagID, "\"");
		if (type) print(" TYPE=\"", inputType, "\"");
		if (checked) print(" CHECKED");
		if (get("maxWidth") < 9999) 
			print(" MAXWIDTH=", get("maxWidth"));
		if (get("minWidth") < 9999) 
			print(" MINWIDTH=", get("minWidth"));
		print(">\n");
		return;
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\width {30}
\height {30}
\
