\name {HTML_input_str}
\class {txtEdit}
\security {1}
\script	{
	switch (arg[0]) {
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 * arg[3]	height
		 */
		set("width", arg[2] - 2);
		return get("height") + 2;
	break;
	case "make":
		/* arg[1]	parent
		 * arg[2]	defaultValue
		 * arg[3]	width
		 * arg[4]	height
		 */
/*		tagPtr = STG_tagPtr("INPUT");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}
*/
		set("parent", arg[1]);
		defaultVal = arg[2];
		set("content", defaultVal);
		set("width", arg[3]);
		set("height", arg[4]);
		return get("height") + 2;
	break;
	case "keyPress":
		if (key() == '\r') {
/*			send(parent(), "setFormVar", get("content"));*/
			if (checkChars) send(self(), "checkChars");
			return;
		}
	break;
	case "checkChars":
		length = strlen(get("content"));
		if (minChars > 0) {
			if (length < minChars) {
				send("www.mesg.tf", "suggest", 
	"Warning, you have entered less characters than suggested\n");
			}
		}
		if (maxChars > 0) {
			if (length < maxChars) {
				send("www.mesg.tf", "suggest", 
	"Warning, you have entered more characters than suggested\n");
			}
		}
	break;
	case "leave":
		if (checkChars) send(self(), "checkChars");
	break;
	case "value":
		return get("content");
	break;
	case "reset":
		set("content", defaultVal);
		clearWindow();
		render();
		return;
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "init":
		usual();
		color = getResource("Viola.background_input");
		if (color) set("BGColor", color);
		color = getResource("Viola.borderColor_input");
		if (color) set("BDColor", color);
		color = getResource("Viola.foreground_input");
		if (color) set("FGColor", color);
		return;
	break;
	}
	usual();
}
\font {fixed}
\verbatim {1}
\BDColor {black}
\BGColor {LemonChiffon3}
\CRColor {red}
\FGColor {black}
\width {100}
\height {33}
\
