\class {hpane}
\security {1}
\name {HMML_hpane}
\script {
	switch (arg[0]) {
	case 'D':
		tagPtr = STG_tagPtr("HPANE");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}

		style = SGMLGetStyle("HMML", "HPANE");
		vspan = style[0];
/*
		print("HMML_hpane::: D: self=", self(), "  width=", width(),  
			" height=", height(), "\n");
*/
		config();
		n = countChildren();
		if (n) {
			xx = (width() - 10) / 2;
			cy = style[1];
			for (i = 0; i < n; i = i + 1) {
				h = send(nthChild(i), 'r');
				if (h > vspan) vspan = h;
			}
		}
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		style = SGMLGetStyle("HMML", "HPANE");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);

/*		print("HMML_hpane::: arg[1]=", 
			arg[1], " arg[2]=", arg[2], "\n");
*/
		config();
		n = countChildren();
		if (n) {
			xx = (width() - 10) / 2;
			cy = style[1];
			for (i = 0; i < n; i = i + 1) {
				h = send(nthChild(i), 'r');
				if (h > vspan) vspan = h;
			}
		}
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "HPANE");
		vspan = style[0];
		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i = i + 1) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case "noBullet":
	case "AI":
		return;
	break;
	case "searchAnchor":
		if (get("content2") == arg[1]) return self();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i = i + 1) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		}
		return "";
	break;
	case "gotoAnchor":
		if (get("content2") == arg[1]) return y();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i = i + 1) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset + y();
			}
		}
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "findForm":
		return send(parent(), "findForm");
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
