\name {HMML_input_doodle}
\parent {}
\class {vpane}
\security {1}
\children {HMML_input_doodle.ctrl HMML_input_doodle.canvas}
\script	{
	switch (arg[0]) {
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		set("width", arg[2]);
		deepObjectListSend("children", "configSelf");
		return get("height") + 2;
	break;
	case "make":
		/* arg[1]	parent
		 * arg[2]	defaultValue
		 * arg[3]	width
		 * arg[4]	height
		 */
/*		tagPtr = STG_tagPtr("INPUT");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}
*/
		set("parent", arg[1]);
		val = arg[2];
		set("width", arg[3]);

		after(1, self(), "configSelf");

		send(nthChild(1), "setup");

		return get("height");
	break;
	case "value":
		return send(nthChild(1), "getVar");
	break;
	case "clone":
		return clone(arg[1]);
	break;
	case "relay1":
		return send(nthChild(1), arg[1]);
	break;
	case "relay2":
		return send(nthChild(1), arg[1], arg[2]);
	break;
	}
	usual();
}
\width {100}
\height {100}
\BGColor {grey45}
\
\class {txtButton}
\security {1}
\name {HMML_input_doodle.ctrl}
\parent	{HMML_input_doodle}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		send(parent(), "relay1", "clear");
	break;
	}
	usual();
}
\label {Clear pad}
\maxHeight {20}
\maxWidth {100}
\BGColor {grey45}
\FGColor {white}
\BDColor {white}
\gapV {2}
\
\class {field}
\security {1}
\name {HMML_input_doodle.canvas}
\parent	{HMML_input_doodle}
\script	{
	switch (arg[0]) {
	case "mouseMove":
		if (penDownP) {
			x0 = x1;
			y0 = y1;
			x1 = arg[1];
			y1 = arg[2];
			drawLine(x0, y0, x1, y1);

			segments[count] = 0;	/* sickie language flaw */
			seg = segments[count];
			seg[0] = x0;
			seg[1] = y0;
			seg[2] = x1;
			seg[3] = y1;
			segments[count] = seg;

			count = count + 1;
			return;
		}
	break;
	case "buttonPress":
		penDownP = 1;
		x0 = mouseX();
		y0 = mouseY();
		x1 = x0;
		y1 = y0;
	break;
	case "buttonRelease":
		penDownP = 0;
	break;
	case "clear":
		count = 0;
		clearWindow();
		return;
	break;
	case "dump":
		for (i = 0; i < count; i = i + 1) {
			seg = segments[i];
			print(i, ":", seg[0], ",", seg[1], 
				" ",  seg[2], ",", seg[3],
				"\n");
		}
		return;
	break;
	case "getVar":
		tt = "";
		for (i = 0; i < count; i = i + 1) {
			seg = segments[i];
			tt = concat(tt, seg[0], ",", seg[1], 
				    ",",  seg[2], ",", seg[3],
				    ";\n");
		}
		return tt;
	break;
	case "expose":
		for (i = 0; i < count; i = i + 1) {
			seg = segments[i];
			drawLine(seg[0], seg[1], seg[2], seg[3]);
		}
		return;
	break;
	case "setup":
		penDownP = 0;
		return;
	break;
	case "init":
		usual();
		penDownP = 0;
		return;
	break;
	}
	usual();
}
\FGColor {black}
\BGColor {LemonChiffon2}
\BDColor {LemonChiffon2}
\
