\class {txtDisp}
\name {HTML__doc}
\script {
print("HTML__doc: self=", self(), ": ");
for (i=0; i<arg[]; i++) print("arg", i, " = ", arg[i], "\n");print("...end\n");

	switch (arg[0]) {
	case "shownPositionV":
		if (isHTML) return set("y", arg[1] * heightRatio);
		else return set("shownPositionV", arg[1]);
	break;
	case 'F': /* flush */
		h = 0;
		SGMLBuildDoc_setBuff(-1); /* bad place to do this */
		if (isBlank(get("label")) == 0) {
			if (style_p == 0) style_p = SGMLGetStyle("HTML", "P");
			txtObj = HTML_txt("clone");
			objectListAppend_children(txtObj);
			h = send(txtObj, "make", self(),
				compressSpaces(get("label")),
				style_p[3], 
				get("width") - style_p[3] - style_p[2],
				SGMLBuildDoc_span(), makeAnchor);
			makeAnchor = 0;
		}
		if (h == 0) return 1;
		set("height", h);
		return h;
	break;
	case 'D':
		h = get("height");
		SGMLBuildDoc_setBuff(0);
		if (isBlank(get("label")) == 0) {
			if (style_p == 0) style_p = SGMLGetStyle("HTML", "P");
			txtObj = HTML_txt("clone");
			objectListAppend_children(txtObj);
			h += send(txtObj, "make", self(), 
				compressSpaces(get("label")),
				style_p[3], 
				get("width") - style_p[3] - style_p[2],
				h, makeAnchor);
			makeAnchor = 0;
		}
		/* IMPORTANT KLUDGE: this is how this object knows whether 
		 * to behave like a single textfield (for ascii only text),
		 * or as container (for compound HTML objects).
		 */
		set("height", h);
		return h;
	break;
	case "expose":
		usual();
		if (isHTML) render();
		return;
	break;
	case "data":
		SGMLBuildDoc_setBuff(-1);
		return compressSpaces(get("label"));
	break;
	case 'T':
		/* arg[1] = y
		 * arg[2] = width
		 *
		 * put this check here rather than 'D' since it may 'D' time
		 * may not occur.
		 */
		if (objectListCount("children") > 0) {
			isHTML = 1;
			h = get("height");
			parentHeight = send(parent(), "heightP");
			heightDiff = h - parentHeight;
			if (heightDiff > 0) {
				heightRatio =  float(heightDiff) / -100.0;
			} else {
				heightRatio = 0;
				h = parentHeight;
			}
			set("height", h);
			prevHeight = h;
		} else {
			prevHeight = get("height");
			h = building_vspan();
		}
		vspan = h;
		prevWidth = arg[2];
		return vspan;
	break;
	case "nameAndURL":
		docName = arg[1];
		docURL = arg[2];
		return;		
	break;
	case "inPreP":
		return 0;
	break;
	case "setAnchor":
		makeAnchor = arg[1];
		return;
	break;
	case "query_docName":
		return docName;
	break;
	case "query_docURL":
		return docURL;
	break;
	case "searchAnchor":
		n = countChildren();
		if (n > 0) 
			for (i = 0; i < n; i++) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		return "";
	break;
	case "gotoAnchor":
		if (tagID == arg[1]) return 0; /* special case */
		n = countChildren();
		if (n > 0)
			for (i = 0; i < n; i++) {
				offset = send(nthChild(i),
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset;
			}
		return 0;
	break;
	case "follow_href":
		return send(parent(), "show_request_by_child", arg[1], docURL);
	break;
	case "post_href_n_data":
		return send(parent(), "post_request_by_child", arg[1], docURL,
							arg[2]);
	break;
	case "hintOn":
		return send(parent(), "hintOn", arg[1]);
	break;
	case "hintOff":
		return send(parent(), "hintOff");
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		set("y", 0);
		send(self(), "resize", arg[2], send(parent(), "heightP")); 
		return h;
	break;
	case "resize":
		/* arg[1]	width (of viewer window)
		 * arg[2]	height (..)
		 * Note: prevWidth & prevHeight also refers to viewer sizes
		 */
		set("width", arg[1]);
		if (isHTML) {
			n = countChildren();
			if (n) {
				xx = arg[1] - 5;
				h = 0;
				for (i = 0; i < n; i++)
					h += send(nthChild(i), 'R', h, xx);
				vspan = h;
			} else {
				vspan = 1;
			}
			parentHeight = send(parent(), "heightP");
			if (vspan < parentHeight) vspan = parentHeight;
			heightDiff = vspan - parentHeight;
			if (heightDiff > 0) {
				heightRatio = float(heightDiff) / -100.0;
			} else {
				heightRatio = 0;
				vspan = parentHeight;
			}
			set("height", vspan);
		} else {
			set("height", arg[2]);
			set("content", get("content"));
			render();
			vspan = building_vspan();
		}
		prevWidth = arg[1];
		prevHeight = arg[2];
		return;
	break;
	case "VIEW_ON":
		for (i = 0; i < toolsCount; i++) send(tools[i], "visible", 1);
		return;
	break;
	case "display":
		/* arg[1]	width (of viewer window)
		 * arg[2]	height (of viewer window)
		 */
		send(self(), "resize", arg[1], arg[2]);
		set("visible", 1);
		if (get("window")) raise();

		for (i = 0; i < toolsCount; i++) {
			send(get("parent"), "addTool", tools[i]);
			send(tools[i], "visible", 1);
		}
		return;
	break;
	case "configSelf":
	case "config":
		return;
	break;
	case "findTop":
		return self();
	break;
	case "widthP":
		return get("width");
	break;
	case "heightP":
		return get("height");
	break;
	case "reportTitle":
		docTitle = arg[1];
		return;
	break;
	case "yP":
		return get("y");
	break;
	case "y":
		return set("y", arg[1]);
	break;
	case "vspan":
		if (isHTML) return get("height");
		return vspan;
	break;
	case "reload":
		set("name", "dunsel");

/*		set("visible", 0);*/

		for (i = 0; i < toolsCount; i++) {
			send(parent(), "destroyTool", tools[i]);
		}
		send("www", "showHistoryDoc", docURL);

		after(10000, self(), "visible", 0);
		after(10001, self(), "freeSelf");
		return 0;
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "keyPress":
		if (key() == 'a') {
			set("BGColor", "red");
		} else if (key() == 'b') {
			set("BGColor", "blue");
		} else if (key() == '?') {
			info();
		}
	break;
	case "show":
		set("visible", 1);
		render();
		if (get("window")) raise();

		for (i = 0; i < toolsCount; i++) send(tools[i], "visible", 1);

		relay_obj[relayIdx] = self();
		relay_event[relayIdx++] = "VIEW_OFF";

		return;
	break;
	case "search":
		return send(parent(), "show_request_by_child", 
				concat(docURL, '?', arg[1]), docURL);
	break;
	case "VIEW_OFF":
		for (i = 0; i < toolsCount; i++)
			send(parent(), "removeTool", tools[i]);
		return;
	break;
	case "blank":
		set("visible", 0);
		for (i = 0; i < toolsCount; i++) 
			send(parent(), "removeTool", tools[i]);
		return;
	break;
	case "queryAddress":
		return docURL;
	break;
	case "queryTitle":
		if (docTitle) return docTitle;
		return docName;
	break;
	case "isIndex":
		return isIndex = 1;
	break;
	case "queryIsIndex":
		return isIndex;
	break;
	case "historyRecord":
		send("wwwHistory", "add", docName, docURL);
		return;
	break;
	case "toDoInsert":
		send(parent(), "toDoInsert", arg[1]);
		return;
	break;
	case "torn":
		/* Variable do not get cloned. So, set variables, 
		 * ie: parentHeight, hightDiff.. 
		 */
		orig = arg[1];

		docName = send(orig, "query_docName");
		docURL = send(orig, "query_docURL");

		send(self(), 'T', 0, get("width")); 
		return;
	break;
	case "output2File":
		send("res.getLineEntry", "show", 
			"Enter file name to save to document source to:", 
				"/tmp/out.html",
				self(), "gotOutputFileName");
		return;
 	break;
	case "gotOutputFileName":
		send("wwwSecurity", "getDocAndMoveItToSpecifiedPlace",
				docURL, arg[1]);
		send("www.mesg.tf", "show", 
			concat("Source saved to file: ", arg[1], "\n"));
		return;
 	break;
	case "showSrc":
		wwwSrc("showByURL", docURL);
		return;
 	break;
	case "reportAuthor":
		author = arg[1];
		return;
	break;
	case "queryAuthor":
		if (author == "") return 0;
		return author;
	break;
	case "outlineSrc":
		send("www.mesg.tf", "show", 
			"Outliner not available for HTML\n");
		return;
	break;
	case "print":
/*
1 - the URL of those documents contain ";" telling the shell that
the instruction ended. you have to go out of viola, and enclose
it in quotation marks.
*/
		send("www.mesg.tf", "show", 
		    "Printing facillity not available for HTML.\n");
		return;
 	break;
	case "freeSelf":
		/* tools should be freed only when an object really is
		 * going away, and when the doc object is named 'dunsel'
		 * the doc is being reloaded.
		 */
/*		if (self() != "dunsel")
			for (i = 0; i < toolsCount; i++)
				send(tools[i], "freeSelf");
*/
		freeSelf();
		return;
	break;
	case "VW_relay":
		relay_obj[relayIdx] = arg[1];
		relay_event[relayIdx++] = arg[2];
		return 1;
	break;
	case "VW_event":
		event = arg[1];
		for (i = 0; i < relayIdx; i++)
			if (relay_event[i] = event) send(relay_obj[i], event);
		return;
	break;
	case "addTool":
		tools[toolsCount] = arg[1];
		toolsCount++;
		return;
	break;
	case "addTool_sticky":
		return send(parent(), "addTool", arg[1]);
	break;
	case "outputSGML":
		print("<HTML>\n");
		n = countChildren();
		if (n) for (i = 0; i < n; i++)
				send(nthChild(i), "outputSGML");
		print("</HTML>\n");
		return;
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\width {590}
\height {200}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\FGColor {black}
\verbatim {1}
\font {fixed}
\
