\class {field}
\security {1}
\name {HTML__txtBox_alert}
\children {HTML__txtBox_alert.txt HTML__txtBox_alert.icon}
\script {
	switch (arg[0]) {
	case "make":
		/* arg[1]	parent
		 * arg[2]	txt
		 * arg[3]	width to use
		 */
		set("parent", arg[1]);
		set("width", arg[3]);
		h = send(nthChild(0), "make", arg[2], arg[3]) + 3;
		set("height", h);
		after(2000, nthChild(1), "tic");
		eventMask("+pointerMotion +leaveWindow");
		return h;
	break;
	case 'R': /* resize */
		set("width", arg[1]);
		h = send(nthChild(0), 'R', arg[1]) + 3;
		set("height", h);
		return h;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	return code_HTML_txt(arg);
}
\width {100}
\height {100}
\BDColor {LemonChiffon1}
\BGColor {lemonChiffon1}
\
\class {txtDisp}
\security {1}
\parent {HTML__txtBox_alert}
\name {HTML__txtBox_alert.txt}
\script {
	switch (arg[0]) {
	case "make":
		/* arg[1]	txt
		 * arg[2]	width to use
		 */
		txt = arg[1];
		set("width", arg[2] - 50);
		set("content", txt);
		h = building_vspan();
		if (h < 32) h = 32;
		set("height", h);
		return h;
	break;
	case 'R': /* resize */
		clearWindow();
		set("width", arg[1] - 50);
		set("content", txt);
		h = building_vspan();
		if (h < 32) h = 32;
		set("height", h);
		render();
		return h;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\x {50}
\width {10}
\height {10}
\BDColor {LemonChiffon1}
\BGColor {lemonChiffon1}
\FGColor {black}
\font {normal}
\format {1}
\
\class {XBM}
\security {1}
\parent {HTML__txtBox_alert}
\name {HTML__txtBox_alert.icon}
\script {
	switch (arg[0]) {
	case "tic":
		invertLine(15,18, x, y);
		second = float(nthWord(date(), 6));
		d = second * 6.0 - 90.0;
		x = 8 * cos(d) + 15;
		y = 8 * sin(d) + 18;
		invertLine(15,18, x, y);
		after(500, self(), "tic");
		return;
	break;
	case "expose":
		usual();
		invertLine(15,18, x, y);
		return;
	break;
	case "init":
		usual();
		d = 270;
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\label {#define alert_width 32
#define alert_height 32
static char alertr_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0x08, 0x0a, 0x00,
   0x00, 0xf8, 0x0f, 0x00, 0x00, 0x40, 0x01, 0x00, 0x00, 0x40, 0x01, 0x00,
   0x00, 0xf0, 0x07, 0x00, 0x00, 0x0c, 0x18, 0x00, 0x00, 0xf3, 0x67, 0x00,
   0x80, 0xfc, 0x9f, 0x00, 0x40, 0xfe, 0xbf, 0x01, 0x40, 0xff, 0x7f, 0x01,
   0xa0, 0xff, 0xff, 0x02, 0xa0, 0xff, 0xff, 0x02, 0xd0, 0xff, 0xff, 0x05,
   0xd0, 0xff, 0xff, 0x07, 0xd0, 0xff, 0xff, 0x05, 0xd0, 0xff, 0xff, 0x07,
   0xd0, 0xff, 0xff, 0x05, 0xd0, 0xff, 0xff, 0x05, 0xd0, 0xff, 0xff, 0x07,
   0xa0, 0xff, 0xff, 0x02, 0xa0, 0xff, 0xff, 0x03, 0x40, 0xff, 0x7f, 0x01,
   0x40, 0xfe, 0xff, 0x01, 0x80, 0xfc, 0xdf, 0x00, 0x00, 0xf3, 0x6f, 0x00,
   0x00, 0x0c, 0x18, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
}
\x {5}
\y {5}
\width {40}
\height {40}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\FGColor {grey30}
\
