\name {HTML_input_percent}
\class {hpane}
\security {1}
\children {HTML_input_percent.v HTML_input_percent.s}
\script	{
	switch (arg[0]) {
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		set("width", arg[2]);
		config();
		return get("height") + 2;
	break;
	case "make":
		/* arg[1]	parent
		 * arg[2]	defaultValue
		 * arg[3]	width
		 * arg[4]	height
		 */
/*		tagPtr = STG_tagPtr("INPUT");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}
*/
		set("parent", arg[1]);
		val = arg[2];
		set("width", arg[3]);
		set("height", arg[4]);
		config();
		objectListSend("children", "_setVar", val);
		return get("height");
	break;
	case "value":
		return send(nthChild(1), "getVar");
	break;
	case "setVar.v":
		val = arg[1];
		send(nthChild(1), "setVar", val);
		return;
	break;
	case "setVar.s":
		val = arg[1];
		send(nthChild(0), "setVar", val);
		return;
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "init":
		usual();
		color = getResource("Viola.borderColor_input");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\BDColor {black}
\y {-1}
\width {100}
\height {17}
\
\parent {HTML_input_percent}
\name {HTML_input_percent.v}
\class {txtEdit}
\security {1}
\shownDepend {HTML_input_percent.s}
\script	{
	switch (arg[0]) {
	case "setVar":
	case "shownPositionH":
		set("content", arg[1]);
		render();
		return;
	break;
	case "_setVar":
		set("content", arg[1]);
		return;
	break;
	case "keyPress":
		if (key() == '\r') {
			v = get("content");
			if (v > 100) {
				v = 100;
				set("content", 100);
				render();
			}
			return;
		}
	break;
	case "init":
		usual();
		color = getResource("Viola.background_input");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_input");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_input");
		if (color) set("BDColor", color);
		color = getResource("Viola.cursorColor_input");
		if (color) set("CRColor", color);
		return;
	break;
	}
	usual();
}
\BDColor {black}
\BGColor {LemonChiffon3}
\FGColor {black}
\CRColor {red}
\maxWidth {30}
\
\class {slider}
\security {1}
\parent {HTML_input_percent}
\name {HTML_input_percent.s}
\shownNotify {HTML_input_percent.v}
\script	{
	switch (arg[0]) {
	case "make":
		/* arg[1]	defaultValue
		 */
		set("shownPositionH", arg[1]);
		return;
	break;
	case "setVar":
		set("shownPositionH", arg[1]);
		render();
		return;
	break;
	case "_setVar":
		set("shownPositionH", arg[1]);
		return;
	break;
	case "getVar":
		return get("shownPositionH");
	break;
	case "buttonRelease":
		send(parent(), "setVar.s", get("content"));
	break;
/*	case "init":
		usual();
		color = getResource("Viola.background_input");
		if (color) set("BGColor", color);
		color = getResource("Viola.borderColor_input");
		if (color) set("BDColor", color);
		color = getResource("Viola.foreground_input");
		if (color) set("FGColor", color);
		return;
	break;
*/
	}
	usual();
}
\shownSizeH {10}
\direction {left2right}
\BDColor {white}
\BGColor {grey45}
\FGColor {grey75}
\
