\name {ed_geometry}
\class {vpane}
\parent {}
\lock {1}
\width {252}
\height {200}
\children {ed_geometry.width ed_geometry.height ed_geometry.maxWidth ed_geometry.maxHeight ed_geometry.minWidth ed_geometry.minHeight ed_geometry.gapH ed_geometry.gapV}
\
\name {ed_geometry.width}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.width.dec ed_geometry.width.inc}
\
\name {ed_geometry.width.dec}
\class	{txtButton}
\parent	{ed_geometry.width}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {width: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"width\", get(\"width\") - 1); send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.width.inc}
\class	{txtButton}
\parent	{ed_geometry.width}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {width: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"width\", width() + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.height}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.height.dec ed_geometry.height.inc}
\
\name {ed_geometry.height.dec}
\class	{txtButton}
\parent	{ed_geometry.height}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {height: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"height\", height() - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.height.inc}
\class	{txtButton}
\parent	{ed_geometry.height}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {height: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(),
"set(\"height\", height() + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.maxWidth}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.maxWidth.dec ed_geometry.maxWidth.inc}
\
\name {ed_geometry.maxWidth.dec}
\class	{txtButton}
\parent	{ed_geometry.maxWidth}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {maxWidth: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"maxWidth\", get(\"maxWidth\") - 1); send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.maxWidth.inc}
\class	{txtButton}
\parent	{ed_geometry.maxWidth}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {maxWidth: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"maxWidth\", get(\"maxWidth\")  + 1); send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.maxHeight}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.maxHeight.dec ed_geometry.maxHeight.inc}
\
\name {ed_geometry.maxHeight.dec}
\class	{txtButton}
\parent	{ed_geometry.maxHeight}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {maxHeight: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"maxHeight\", get(\"maxHeight\")  - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.maxHeight.inc}
\class	{txtButton}
\parent	{ed_geometry.maxHeight}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {maxHeight: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"maxHeight\", get(\"maxHeight\")  + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.minWidth}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.minWidth.dec ed_geometry.minWidth.inc}
\
\name {ed_geometry.minWidth.dec}
\class	{txtButton}
\parent	{ed_geometry.minWidth}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {minWidth: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"minWidth\", get(\"minWidth\")  - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.minWidth.inc}
\class	{txtButton}
\parent	{ed_geometry.minWidth}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {minWidth: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"minWidth\", get(\"minWidth\")  + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.minHeight}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.minHeight.dec ed_geometry.minHeight.inc}
\
\name {ed_geometry.minHeight.dec}
\class	{txtButton}
\parent	{ed_geometry.minHeight}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {minHeight: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"minHeight\", get(\"minHeight\")  - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.minHeight.inc}
\class	{txtButton}
\parent	{ed_geometry.minHeight}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {minHeight: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"minHeight\", get(\"minHeight\")  + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.gapH}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.gapH.dec ed_geometry.gapH.inc}
\
\name {ed_geometry.gapH.dec}
\class	{txtButton}
\parent	{ed_geometry.gapH}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {gapH: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"gapH\", get(\"gapH\") - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.gapH.inc}
\class	{txtButton}
\parent	{ed_geometry.gapH}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {gapH: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"gapH\", get(\"gapH\") + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.gapV}
\class {hpane}
\parent {ed_geometry}
\lock {1}
\children {ed_geometry.gapV.dec ed_geometry.gapV.inc}
\
\name {ed_geometry.gapV.dec}
\class	{txtButton}
\parent	{ed_geometry.gapV}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {gapV: -1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"gapV\", get(\"gapV\") - 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
\name {ed_geometry.gapV.inc}
\class	{txtButton}
\parent	{ed_geometry.gapV}
\lock {1}
\BDColor {white}
\BGColor {grey45}
\BGColor {grey70}
\label {gapV: +1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		tweak(target(), 
"set(\"gapV\", get(\"gapV\") + 1);send(parent(), \"configSelf\");");
	break;
	}
	usual();
}
\
