\class {field}
\security {1}
\name {HMML_doc}
\script {
/*	print("@@@@@@ HMML_doc clsss = txtDisp: args: ");
	for (i =0; i < arg[]; i++) print(arg[i], ", ");
	print("\n");
*/
	switch (arg[0]) {
	case "shownPositionV":
		set("y", arg[1] * heightRatio);
		return;
	break;
	case "D":
		tagPtr = STG_tagPtr("BODY");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}

		h = SGMLBuildDoc_span();
		set("height", h);
		return h;
	break;
	case 'T':
		/* arg[1] = y
		 * arg[2] = width
		 */
		h = get("height");
		parentHeight = send(parent(), "heightP");
		heightDiff = h - parentHeight;
		if (heightDiff > 0) {
			heightRatio =  float(heightDiff) / -100.0;
		} else {
			heightRatio = 0;
			h = parentHeight;
			set("height", h);
		}
		prevWidth = arg[2];
		prevHeight = parentHeight;
		return h;
	break;
	case "nameAndURL":
		docName = arg[1];
		docURL = arg[2];
		return;
	break;
	case "query_docName":
		return docName;
	break;
	case "query_docURL":
		return docURL;
	break;
	case "searchAnchor":
		n = countChildren();
		if (n > 0)
			for (i = 0; i < n; i++) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		return "";
	break;
	case "follow_href":
/*		return send(parent(), "show_request_by_child", arg[1], docURL);*/
		return code_HTML_txt(arg);
	break;
	case "hintOn":
		return send(parent(), "hintOn", arg[1]);
	break;
	case "hintOff":
		return send(parent(), "hintOff");
	break;
	case "gotoAnchor":
		return code_HTML_txt(arg);
/*		n = countChildren();
		if (n > 0)
			for (i = 0; i < n; i++) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset;
			}
		return 0;
*/
	break;
	case "resize":
		/* arg[1]	width (of viewer window)
		 * arg[2]	height (..)
		 * 
		 * Note: prevWidth & prevHeight also refers to viewer sizes
		 */
		if (prevWidth != arg[1]) {
			loadDoc = 1;
		} else if (prevHeight != arg[2]) {
			loadDoc = 1;
		} else {
			loadDoc = 0;
		}
		if (loadDoc == 1) {
			set("y", 0);
			set("width", arg[1]);
			set("height", 9999); /* enough space to render text */
			n = countChildren();
			if (n) {
				xx = arg[1] - 5;
				h = 0;
				for (i = 0; i < n; i++)
					h += send(nthChild(i), 'R', h, xx);
				vspan = h;
			} else {
				vspan = 1;
			}
		}
		parentHeight = send(parent(), "heightP");
		if (vspan < parentHeight) {
			vspan = parentHeight;
		}
		heightDiff = vspan - parentHeight;
		if (heightDiff > 0) {
			heightRatio =  float(heightDiff) / -100.0;
		} else {
			heightRatio =  0;
			vspan = parentHeight;
		}
		set("height", vspan);

		prevWidth = arg[1];
		prevHeight = arg[2];
		return;
	break;
	case "display":
		/* arg[1]	width (of viewer window)
		 * arg[2]	height (of viewer window)
		 */
		raise();
		if (arg[1] != prevWidth) {
			/* need to re-format */
			send(self(), "resize", arg[1], arg[2]);
		} else if (arg[2] != prevHeight) {
			/* just adjust window height */
			send(self(), "resize", arg[1], arg[2]);
		}
		return;
	break;
	case "findTop":
		return self();
	break;
	case "reportTitle":
		docTitle = arg[1];
		return;
	break;
	case "yP":
		return y();
	break;
	case "y":
		return set("y", arg[1]);
	break;
	case "heightP":
	case "vspan":
		return height();
	break;
	case "noBullet":
		return; /*??*/
	break;
	case "reload":
		set("name", "dunsel");
		send("www", "show", docURL);
		after(1000, self(), "visible", 0);
		after(1001, self(), "freeSelf");
		return 0;
	break;
	case "clone":
		return clone(arg[1]);
	break;
	case "show":
		set("visible", 1);
		raise();
		return;
	break;
	case "blank":
/*
print("HEY, BLNK SELF=", self(),". WINDOW! w=", get("window"), "\n");
print(" name =", get("name"), "\n");
*/
		set("visible", 0);
		return;
	break;
	case "queryAddress":
		return docURL;
	break;
	case "queryTitle":
		if (docTitle != "") return docTitle;
		return docName;
	break;
	case "queryIsIndex":
		return isIndexP;
	break;
	case "search":
		return send(parent(), "show_request_by_child", 
				concat(docURL, '?', arg[1]), docURL);
	break;
	case "reportIsIndex":
		isIndexP = 1;
		return;
	break;
	case "historyRecord":
/*print(">>>>>>>>>>>>>>docName=", docName, "\n");
print(">>>>>>>>>>>>>>docURL=", docURL, "\n");
*/
		send("mvw", "addToHistory", docName, docURL);
		return;
	break;
	case "torn":
		/* Variable do not get cloned. So, set variables, 
		 * ie: parentHeight, hightDiff.. 
		 */
		orig = arg[1];
		docName = send(orig, "query_docName");
		docURL = send(orig, "query_docURL");
/*
print("HMML_doc ", arg[1], "\n");
print("@@@@@@ TORN: orig={", orig, "}\n");
print("@@@@@@ TORN: docURL={", docURL, "}\n");
*/
		send(self(), 'T'); 
		return;
	break;
	case "output2File":
		if (nthChar(docURL, strlen(docURL) - 1) == 'b')
			tmpFileName = "/tmp/out.hmmlb";
		else
			tmpFileName = "/tmp/out.hmml";

		res.getLineEntry("show", 
			"Enter file name to save to document source to:", 
			tmpFileName, self(), "gotOutputFileName");
		return;
 	break;
	case "gotOutputFileName":
		dumpFile = HTTPGet(docURL);
		system(concat("mv ", dumpFile, " ", arg[1]));
		www.mesg.tf("show", 
			concat("Source saved to file: ", arg[1], "\n"));
		return;
 	break;
	case "showSrc":
		if (nthChar(docURL, strlen(docURL) - 1) == 'b') {
			wwwSrc("showByURL",
				nthChar(docURL, 0, strlen(docURL) - 2));
			res.dialogWithButtons("show", 
		    concat("For actual HMMLB source, please refer to:\n",
						 "docName: ", docName, 
						 "\nDoc URL: ", docURL),
					"OK", "");
		} else {
			wwwSrc("showByURL", docURL);
		}
		return;
 	break;
	case "outlineSrc":
		www.mesg.tf("show", 
			    concat("Outliner not available for HMML\n"));
		return;
	break;
	case "print":
		www.mesg.tf("show", 
		    concat("Printing facillity not available for HMML.\n"));
		return;
 	break;
	case "freeSelf":
		freeSelf();
		return;
	break;
	case "VW_relay":
/*print("HMML_doc: relay obj={", arg[1], "} event={", arg[2], "}\n");*/
		relay_obj[relayIdx] = arg[1];
		relay_event[relayIdx] = arg[2];
	 	relayIdx= relayIdx + 1;
		return 1;
	break;
	case "VW_event":
		event = arg[1];
		for (i = 0; i < relayIdx; i++) {
			if (relay_event[i] = event) {
/*print("HMML_doc: relay'ING obj={", relay_obj[i], "} event={", event, "}\n");
*/
				send(relay_obj[i], event);
			}
		}
		return;
	break;
	}
	usual();
}
\font {normal_large}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\FGColor {black}
\
