\class {txtDisp}
\security {1}
\name {HMML_fail}
\script {
	/* Failure notice.
	 * This object is used to display insertions that failed. 
	 * See HMML_vobjf.v for usage example.
	 */
	switch (arg[0]) {
	case "make":
		/* arg[1]	parent
		/* arg[2]	width
		 * arg[3]	message
		 */
		set("parent", arg[1]);
		set("width", arg[2]);
		set("content", arg[3]);
		set("height", building_vspan());
		return (building_vspan() + 2);
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		clearWindow();
		style = SGMLGetStyle("HMML", "LISTING");
		vspan = style[0];
		set("y", arg[1] + vspan);
		set("x", style[2]);
		set("width", arg[2] - x() - style[3]);
		set("content", get("content"));
		vspan += set("height", building_vspan()) + style[1];
		render();
		return vspan;
	break;
	case "clone":
		id = id + 1;
		return clone(id);
	break;
	}
	usual();
}
\width {100}
\height {30}
\font {fixed}
\format {1}
\BGColor {maroon}
\BDColor {maroon}
\FGColor {white}
\
