\class {field}
\security {1}
\name {HMML_listFld}
\script {
	switch (arg[0]) {
	case 'D':
		h = SGMLBuildDoc_span();
		set("height", h);
		return h;
	break;
	case 'L':
		return 'U';
	break;
	case "expose":
		send(parent(), "noBullet");
	break;
	case "noBullet":
		send(parent(), "noBullet");
		return;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);

		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i = i + 1) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		set("width", width() - style[3]);
		set("content", get("content"));
		vspan = vspan + set("height", building_vspan()) + style[1];
		return vspan;
	break;
	case "searchAnchor":
		if (get("content2") == arg[1]) return self();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i = i + 1) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		}
		return "";
	break;
	case "gotoAnchor":
		if (get("content2") == arg[1]) return y();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i = i + 1) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset + y();
			}
		}
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
