\class {field}
\security {1}
\name {HMML_listSep}
\script {
	switch (arg[0]) {
	case 'D':
		if (send(parent(), "compact")) saveSpace = 6;

		if (specialInsertOccured == 1) {
			h = send(self(), 'R', y(), width(), x()) - saveSpace;
			after(1, self(), "visible", 0);/* hack */
			after(1, self(), "visible", 1);
		} else {
			h = SGMLBuildDoc_span() - saveSpace;
		}
		return h;
	break;
	case 'F':
		/* create and set insertObject before 'D', so flush this obj
		 */
		y = SGMLBuildDoc_span();
		listType = send(parent(), 'L');

		if (first == 0) {
			first = 1;
			switch (listType) {
			case 'U':	/* UL */
				bulletObj = HMML_listBullet("make", self());
				objectListAppend_children(bulletObj);
				x_offset = 20;
			break;
			case 'O':	/* OL */
				/*bulletObj = HMML_listNum("make", self());*/
				bulletObj = HMML_listNum_oval("make", self());
				objectListAppend_children(bulletObj);
				x_offset = 30;
			break;
			default:
				x_offset = 20;
			break;
			}
		}

		/* in case there's text before <LI> */

		txt = get("label");
		if (isBlank(txt) == 0) {
			new = HMML_listTxt("clone");
			w = get("width") - 30;
			h = send(new, "make", self(), 0, w, x_offset,
				txt);
			objectListAppend_children(new);
			specialInsertOccured = 1;
		}

		switch (listType) {
		case 'U':	/* UL */
			listItemContainer = HMML_listItem("clone");
			w = width() - 30;
			txtH = send(listItemContainer, "make", self(), 
					20, y, w);
			SGMLBuildDoc_insertObj(listItemContainer, w);

			return -1;
		break;
		case 'O':	/* OL */
			listItemContainer = HMML_listItem("clone");
			w = width() - 40;
			txtH = send(listItemContainer, "make", self(), 
					30, y, w);
			SGMLBuildDoc_insertObj(listItemContainer, w);

			return -1;
		break;
		case 'D':	/* DIR */
			listItemContainer = HMML_listItem("clone");
			w = width() - 30;
			txtH = send(listItemContainer, "make", self(), 
					20, h, w);
			SGMLBuildDoc_insertObj(listItemContainer, w);

			return -1;
		break;
		case 'M':	/* MENU */
		default:
			listItemContainer = HMML_listItem("clone");
			w = width() - 30;
			txtH = send(listItemContainer, "make", self(), 
					20, h, w);
			SGMLBuildDoc_insertObj(listItemContainer, w);

			return -1;
		break;
		}
		return h;
	break;
	case 'R': /* resize */
		/* arg[1]	y
		 * arg[2]	width
		 * arg[3]	x (optional)
		 */
		if (style == 0) style = SGMLGetStyle("HMML", "LI");
		vspan = style[0];
		set("y", arg[1] + vspan);
		set("width", arg[2] - style[3]);
		if (arg[] == 4) set("x", arg[3]);
		n = countChildren();
		if (n) {
			xx = width();
			for (i = 1; i < n; i = i + 1) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx)
					- saveSpace;
			}
		}
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case "AA":
		switch (arg[1]) {
		case "SRC":/* for icons ?*/
		break;
		}
		return;
	break;
	case "AI":
		return;
	break;
	case "itemN":
		send(nthChild(0), "label", arg[1]);
		return;
	break;
	case "config":
		return;
	break;
	case "gotoAnchor":
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "clone":
		return clone(cloneID());
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
