\class {field}
\security {1}
\name {HMML_vobjf}
\script {
	switch (arg[0]) {
	case 'D':
		docURL = get("label");

		localFile = HTTPGet(docURL);

		addrInfo = HTTPCurrentDocAddrParsed(localFile);

		if (nthChar(addrInfo[2], 0) == '/') {
			path = addrInfo[2];
		} else {
			path = concat("/", addrInfo[2]);
		}
		objFileName = addrInfo[3];

		addrInfo = HTTPCurrentDocAddrParsed(docURL);
		objName = nthChar(addrInfo[3], 0, strlen(addrInfo[3]) - 3);

		stat = loadObjFile(path, objFileName);

		system(concat("rm -f ", localFile));

		if (stat <= 0) {
			print("failed to load obj file {", objFileName,
				"} in {", path, "}\n");
			
			new = send("HMML_fail", "clone");
			set("children", new);
			vspan = send(new, "make", self(), width(),
				     concat("Insert failed here: ", docURL));
			return vspan;
		}
		send(objName, "init");

		set("children", objName);
		tweak(objName, concat("set(\"parent\", \"", self(), "\");"));

		deepObjectListSend("children", "configSelf");

		vspan = tweak(nthChild(0), "height();");
		return vspan;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		style = SGMLGetStyle("HMML", "VOBJF");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);
		vspan = tweak(nthChild(0), "height();");
		set("height", vspan);
		vspan = vspan + style[1];
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "VOBJF");
		set("width", width() - style[3]);
		vspan = tweak(nthChild(0), "height();");
		return vspan;
	break;
	case "AA":
		switch (arg[1]) {
		case "MAXWIDTH":
			set("maxWidth", arg[2]);
			print("MAXWIDTH = ", get("maxWidth"), "\n");
		break;
		case "MINWIDTH":
			set("minWidth", arg[2]);
			print("MINWIDTH = ", get("minWidth"), "\n");
		break;
		}
		return;
	break;
	case "AI":
		return;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "gotoAnchor":
		return "";
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
