\name {testSocket}
\class {vpane}
\x {500}
\width {500}
\height {200}
\children {testSocket.top testSocket.view}
\
\name {testSocket.top}
\class {txtLabel}
\parent	{testSocket}
\label {testSocket : Load}
\maxHeight {20}
\script	{
	switch (arg[0]) {
	case "keyPress":
		testSocket.view.doc.tf("saveText");
		return;
	break;
	case "buttonRelease":
		testSocket.view.doc.tf("init");
		return;
	break;
	}
	usual();
}
\
\name	{testSocket.view}
\class	{hpane}
\parent	{testSocket}
\children {testSocket.view.sb testSocket.view.doc}
\
\name	{testSocket.view.sb}
\class	{slider}
\parent	{testSocket.view}
\BDColor {grey99}
\BGColor {grey45}
\FGColor {grey70}
\shownNotify {testSocket.view.doc.tf}
\maxWidth {20}
\
\name	{testSocket.view.doc}
\parent	{testSocket.view}
\class	{hpane}
\script	{
	switch (arg[0]) {
	case "saveText":
		saveFile(".testSocketCmds", get("content"));
		return;
	break;
	case "config":
		config(arg[1], arg[2], arg[3], arg[4]);
		return;
	break;
	case "render":
/*		raise();*/
	break;
	}
	usual();
}
\children {testSocket.view.doc.tf}
\BDColor {black}
\BGColor {black}
\format {1}
\
\name {testSocket.view.doc.tf}
\parent	{testSocket.view.doc}
\class {txtEdit}
\shownDepend {testSocket.view.sb}
\script	{
	switch (arg[0]) {
	case "newData":
		insert(arg[1]);
		return;
	break;
	}
	usual();
}
\content {
}
\font {fixed}
\BDColor {black}
\BGColor {LemonChiffon3}
\CRColor {yellow}
\FGColor {black}
\
\name {testSocket.socket}
\class {socket}
\parent	{testSocket}
\host {localhost}
\port {7000}
\inDelimStr1 {say}
\inDelimStr2 {
}
\script	{
	switch (arg[0]) {
	case "input":
		idata = input();
		print("INPUT: {", idata, "}\n");
		send("testSocket.view.doc.tf", "newData", idata);
		return;
	break;
	case "output":
		print("OUTPUT'ing: {", arg[1], "}\n");
		output(arg[1]);
		return;
	break;
	case "init":
		usual();
		startClient();
		return;
	break;
	}
	usual();
}
\
