\class {hpane}
\name {www.top2}
\parent {www}
\children {www.top2.icon www.top2.links_public www.top2.links_local www.top2.links_private www.top2.mark www.top2.gap1 www.top2.prev www.top2.back www.top2.next www.top2.home www.top2.gap2}
\maxHeight {32}
\BDColor {55 55 55}
\BGColor {grey45}
\FGColor {white}
\
\class {txtButton}
\name {www.top2.home}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www("home");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click the house icon to visit home page.";
	break;
	}
	usual();
}
\label {Home}
\maxWidth {32}
\BDColor {white}
\BGColor {grey45}
\FGColor {99 99 99}
\gapH {1}
\gapV {2}
\
\class {txtButton}
\name {www.top2.back}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www("back");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return concatenate("Click to go back. document = ",
				wwwHistory("peek_back"));
	break;
	}
	usual();
}
\gapH {1}
\gapV {2}
\label {Back}
\maxWidth {32}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\
\class {txtButton}
\name {www.top2.mark}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		pageObj = www.doc.view("whichPageP");
		title = send(pageObj, "queryTitle");
		address = send(pageObj, "queryAddress");
		www.top2.links_private("add", title, address);
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click it to mark the current document.";
	break;
	}
	usual();
}
\label {Mark}
\maxWidth {36}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\gapH {1}
\gapV {2}
\
\class {menu}
\name {www.top2.links_private}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concatenate(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "save":
		prompt("show", 
			concat("Saving private bookmarks to: ", path, "."));
		status = saveFile(path, get("menuConfig"));
		if (status == -1) 
			prompt("show", 
				concat("Warning: failed to save private bookmarks to: ", path, "."));
		return;
	break;
	case "clear_file":
		dialog("will clear file too, sure?", 
			self(), "clear_file_really");
		return;
	break;
	case "clear_file_really":
		saveFile(path, "");
	break;
	case "clear":
		set("menuConfig", "");
		return;
	break;
	case "edit":
		prompt("show", "firing up editor to edit private bookmarks");
		system(concat("xterm -e emacs -nw ", path, "&"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks");
		if (path == "") path = accessible(".WWWBookMarks");
		if (path == "") path = accessible("~/.WWWBookMarks");
		if (path == "") path = accessible("~/WWWBookMarks");
		if (path == "") path = accessible("~/WWW/BookMarks");

		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Personal private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{}}
\label {Private}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {SlateGray1}
\font {normal}
\gapH {1}
\gapV {2}
\
\class {menu}
\name {www.top2.links_local}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concatenate(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks_local");
		if (path == "") path = accessible(".WWWBookMarks_local");
		if (path == "") path = accessible("~/.WWWBookMarks_local");
		if (path == "") path = accessible("~/WWWBookMarks_local");
		if (path == "") path = accessible("~/WWW/BookMarks_local");

		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Personal private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{/usr/local/lib/WWW/default.html} {www("show", "/usr/local/lib/WWW/default.html");}
}
\label {Local}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {SlateGray1}
\font {normal}
\gapH {1}
\gapV {2}
\
\class {menu}
\name {www.top2.links_public}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concatenate(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks_public");
		if (path == "") path = accessible(".WWWBookMarks_public");
		if (path == "") path = accessible("~/.WWWBookMarks_public");
		if (path == "") path = accessible("~/WWWBookMarks_public");
		if (path == "") path = accessible("~/WWW/BookMarks_public");
		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{Web Overview} {www("show", "http://info.cern.ch./hypertext/DataSources/bySubject/Overview.html");}
.{Web Project} {www("show", "http://info.cern.ch/hypertext/WWW/TheProject.html");}
.{Web Servers} {www("show", "http://info.cern.ch/hypertext/DataSources/WWW/Servers.html");}
.{\\}
.{Information By Subject} {www("show", "http://info.cern.ch/hypertext/DataSources/bySubject/Physics/HEP.html");}
.{WAIS Interface} {www("show", "http://info.cern.ch./hypertext/DataSources/WAIS/ByHost.html");}
.{Gopher Interface} {www("show", "gopher://gopher.micro.umn.edu:70/11/Other%20Gopher%20and%20Information%20Servers");}
.{HyTelnet Interface} {www("show", "http://info.cern.ch.:8002/w3start.txt");}
.{Techinfo Interface} {www("show", "http://info.cern.ch:8004/");}
.{Archie Interface} {www("show", "http://info.cern.ch:8001/archive.orst.edu:9000/archie-orst.edu");}
.{\\}
.{NCSA Home Page} {www("show", "http://hoohoo.ncsa.uiuc.edu/welcome.html");}
.{CERN Home Page} {www("show", "http://info.cern.ch/");}
.{Ohio State Home Page} {www("show", "http://www.cis.ohio-state.edu:80/hypertext/information/information.html");}
.{SLAC Home Page} {www("show", "http://slacvm.slac.stanford.edu./FIND/SLAC.HTML");}
.{HEP Overview} 
.{SIGGRAPH Bibliography} {www("show", "http://iicm.tu-graz.ac.at:80/CSIGGRAPHbib");}
.{Cornell Law School} {www("show", "http://fatty.law.cornell.edu.:80/usr2/wwwtext/lii.table.html");}
.{\\}
.{SunOS 4.1.1 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/sunos.top2.html");}
.{HP/UX 8.0.7 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/hpux.top2.html");}
.{Ultrix 4.2a Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/ultrix.top2.html");}
.{Pyramid OSx Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/pyramid.top2.html");}
.{AIX Man Pages} {www("show", "http://hoohoo.ncsa.uiuc.edu:1235/man/index");}
.{X11R5 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/x11.top2.html");}
.{VMS Man pages} {www("show", "http://slacvx.slac.stanford.edu:80/HELP");}
.{\\}
.{Gopherspace Overview} gopher://gopher.micro.umn.edu:70/11/Other%20Gopher%20and%20Information%20Servers
.{\\}
.{NCSA Gopher} {www("show", "gopher://gopher.ncsa.uiuc.edu:70/1");}
.{CTC Gopher} {www("show", "gopher://gopher.tc.cornell.edu:70/1");}
.{PSC Gopher} {www("show", "gopher://pscuxb.psc.edu:1563/1");}
.{SDSC Gopher} {www("show", "gopher://gopher.sdsc.edu:70/1");}
.{\\}
.{UMN Gopher} {www("show", "gopher://gopher.micro.umn.edu:70/1");}
.{UIUC Gopher} {www("show", "gopher://gopher.uiuc.edu:70/1");}
}
\label {Public}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {SlateGray1}
\font {normal}
\gapH {1}
\gapV {2}
\
\class {field}
\name {www.top2.gap1}
\parent {www.top2}
\BDColor {grey45}
\BGColor {grey45}
\maxWidth {10}
\
\class {field}
\name {www.top2.gap2}
\parent {www.top2}
\BDColor {grey45}
\BGColor {grey45}
\maxWidth {2}
\
\class {menu}
\name {www.top2.icon}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "quit":
		res.dialogWithButtons("show", "Really want to quit viola?",
					"Quit", "www(\"quit\");",
					"Cancel", "");
		return;
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to see some general project information.";
	break;
	}
	usual();
}
\menuConfig {
.{About ViolaWWW} {www("about");}
.{Help for ViolaWWW} {www("help");}
.{\\}
.{Show history list} {wwwHistory("render");}
.{\\}
.{Scrollbar...}
..{left side}	{www.doc.view("sliderConfig", "left");}
..{right side}	{www.doc.view("sliderConfig", "right");}
..{no where}	{www.doc.view("sliderConfig", "none");}
.{GUI Config..}
..{iconic top, has URL}		{www("GUIConfig", "top,URL");}
..{iconic top, no URL}		{www("GUIConfig", "top,noURL");}
..{simple top, has URL}		{www("GUIConfig", "top2,URL");}
..{simple top, no URL}		{www("GUIConfig", "top2,noURL");}
.{\\}
.{Quit} {send(self(), "quit");}
}
\label {Ops}
\maxWidth {45}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {SlateGray1}
\font {normal}
\gapH {1}
\gapV {2}
\
\class {txtButton}
\name {www.top2.help}
\parent {www.top2}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www("help");
/*		www("show", "/usr/work/test.html");
*/
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click it to access a guide to this application.";
	break;
	}
	usual();
}
\gapH {1}
\gapV {2}
\label {Help}
\maxWidth {32}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\
