\name {wwwHTMLSrc}
\class {vpane}
\parent {}
\children {wwwHTMLSrc.top wwwHTMLSrc.list wwwHTMLSrc.ctrl}
\script	{
	switch (arg[0]) {
	case "show":
		/* arg[1]	call back object
		 * arg[2]	HTMLAddress
		 * arg[3]	HTMLSource
		 */
		cloneID = cloneID + 1;
		new = clone(cloneID);
		send(new, "show_clone", arg[1], arg[2], arg[3]);
		send(new, "render");
		return;
	break;
	case "show_clone":
		caller = arg[1];
		HTMLAddress = arg[2];
		HTMLSource = arg[3];
		send(nthChild(0), "show", HTMLAddress);
		send(nthChild(1), "show", HTMLSource);
		return;
	break;
	case "apply":
		send(caller, "updateSrc", send(nthChild(1), "contentP"));
		return;
	break;
	case "store":
/*
		tmp = makeTempFile();
		saveFile(tmp, send(nthChild(1), "contentP"));
		print("ERROR: Sorry, source update feature doesn't yet exist. The changed document is saved in ", tmp, ".\n");
*/
		res.getLineEntry("show", 
			"Enter file name to save to document source to:", 
				"/tmp/out.html",
				self(), "gotOutputFileName");
		return;
	break;
	case "gotOutputFileName":
		if (saveFile(arg[1], send(nthChild(1), "contentP"))) {
			www.mesg.tf("show", 
				concatenate("Source saved to file: ",
					arg[1], "\n"));
		} else {
			www.mesg.tf("show", 
				concatenate("Failed to save source to file: ",
					arg[1], "\n"));
		}
		return;
 	break;
	case "dismiss":
		set("visible", 0);
		return;
	break;
	case "init":
		cloneID = 0;
	break;
	}
	usual();
}
\width {600}
\height {400}
\
\name {wwwHTMLSrc.top}
\class {txtDisp}
\parent	{wwwHTMLSrc}
\font {normal}
\script	{
	switch (arg[0]) {
	case "show":
		set("label", arg[1]);
		return;
	break;
	}
	usual();
}
\maxHeight {20}
\BDColor {black}
\BGColor {LemonChiffon3}
\FGColor {black}
\
\name {wwwHTMLSrc.list}
\class {hpane}
\parent {wwwHTMLSrc}
\script	{
	switch (arg[0]) {
	case "show":
		send(nthChild(0), "show", arg[1]);
		return;
	break;
	case "contentP":
		return send(nthChild(0), "contentP");
	break;
	}
	usual();
}
\children {wwwHTMLSrc.list.tf wwwHTMLSrc.list.sb}
\
\name {wwwHTMLSrc.list.sb}
\class {slider}
\parent {wwwHTMLSrc.list}
\shownNotify {wwwHTMLSrc.list.tf}
\BDColor {grey45}
\BGColor {grey45}
\FGColor {white}
\maxWidth {20}
\
\name {wwwHTMLSrc.list.tf}
\parent {wwwHTMLSrc.list}
\class {txtEdit}
\script	{
	switch (arg[0]) {
	case "show":
		set("content", arg[1]);
		return;
	break;
	case "contentP":
		return get("content");
	break;
	}
	usual();
}
\shownDepend {wwwHTMLSrc.list.sb}
\font {fixed}
\BGColor {grey24}
\FGColor {70 90 70}
\verbatim {1}
\
\name {wwwHTMLSrc.ctrl}
\class {hpane}
\parent	{wwwHTMLSrc}
\maxHeight {20}
\children {wwwHTMLSrc.ctrl.apply wwwHTMLSrc.ctrl.store wwwHTMLSrc.ctrl.dismiss}
\script	{
	switch (arg[0]) {
	case "apply":
	case "store":
	case "dismiss":
		send(get("parent"), arg[0]);
		return;
	break;
	}
	usual();
}
\gapV {1}
\
\name {wwwHTMLSrc.ctrl.apply}
\class {txtButton}
\parent	{wwwHTMLSrc.ctrl}
\font {normal}
\label {Apply Changes}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		send(get("parent"), "apply");
	break;
	}
	usual();
}
\BGColor {grey45}
\BDColor {white}
\FGColor {white}
\
\name {wwwHTMLSrc.ctrl.store}
\class {txtButton}
\parent	{wwwHTMLSrc.ctrl}
\font {normal}
\label {Store Changes}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		send(get("parent"), "store");
	break;
	}
	usual();
}
\BGColor {grey45}
\BDColor {white}
\FGColor {white}
\
\name {wwwHTMLSrc.ctrl.dismiss}
\class {txtButton}
\parent	{wwwHTMLSrc.ctrl}
\font {normal}
\label {Dismiss}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		send(get("parent"), "dismiss");
	break;
	}
	usual();
}
\BGColor {grey45}
\BDColor {white}
\FGColor {white}
\
