\name {wwwSrc}
\class {vpane}
\parent {}
\script	{
	switch (arg[0]) {
	case "show":
		cloneID = cloneID + 1;
		new = clone(cloneID);
		send(new, "show_clone", arg[1], arg[2]);
		send(new, "visible", 1);
		return;
	break;
	case "showByURL":
		cloneID = cloneID + 1;
		new = clone(cloneID);
		send(new, "show_cloneByURL", arg[1]);
		send(new, "visible", 1);
		return;
	break;
	case "show_clone":
		send(nthChild(1), "show", arg[1]);
		send(nthChild(2), "show", arg[2]);
		return;
	break;
	case "show_cloneByURL":
		send(nthChild(1), "show", arg[1]);
		send(nthChild(2), "getAndShow", arg[1]);
		return;
	break;
	case "apply":
		send(nthChild(2), "contentP");
		return;
	break;
	case "dismiss":
		set("visible", 0);
		return;
	break;
	case "init":
		cloneID = 0;
	break;
	}
	usual();
}
\width {600}
\height {400}
\children {wwwSrc.ctrl wwwSrc.top wwwSrc.list}
\
\name {wwwSrc.ctrl}
\class {hpane}
\parent	{wwwSrc}
\font {normal}
\children {wwwSrc.ctrl.ops wwwSrc.ctrl.title}
\maxHeight {25}
\gapV {2}
\script	{
	switch (arg[0]) {
	case "dismiss":
		return send(parent(), "dismiss");
	break;
	}
	usual();
}
\
\name {wwwSrc.ctrl.ops}
\class {menu}
\parent	{wwwSrc.ctrl}
\label {File}
\menuConfig {
. {Print   (not yet)}
. {Mail to (not yet)}
. {Dismiss} {send(get("parent"), "dismiss");}
}
\BGColor {grey45}
\BDColor {white}
\FGColor {white}
\font {normal}
\maxWidth {100}
\
\name {wwwSrc.ctrl.title}
\class {txtLabel}
\parent	{wwwSrc.ctrl}
\label {URL Source Listing}
\font {normal}
\BGColor {grey45}
\FGColor {white}
\
\name {wwwSrc.top}
\class {txtDisp}
\parent	{wwwSrc}
\font {fixed}
\script	{
	switch (arg[0]) {
	case "show":
		set("content", arg[1]);
		return;
	break;
	}
	usual();
}
\maxHeight {30}
\BGColor {LemonChiffon3}
\FGColor {black}
\
\name {wwwSrc.list}
\class {hpane}
\parent {wwwSrc}
\script	{
	switch (arg[0]) {
	case "show":
	case "getAndShow":
		send(nthChild(0), arg[0], arg[1]);
		return;
	break;
	case "contentP":
		return send(nthChild(0), "contentP");
	break;
	}
	usual();
}
\children {wwwSrc.list.tf wwwSrc.list.sb}
\
\name {wwwSrc.list.sb}
\class {slider}
\parent {wwwSrc.list}
\shownNotify {wwwSrc.list.tf}
\BDColor {white}
\BGColor {grey45}
\FGColor {grey75}
\maxWidth {20}
\
\name {wwwSrc.list.tf}
\parent {wwwSrc.list}
\class {txtDisp}
\script	{
	switch (arg[0]) {
	case "show":
		set("content", arg[1]);
		return;
	break;
	case "getAndShow":
		localFile = HTTPGet(arg[1]);
		set("content", loadFile(localFile));
		system(concat("rm -f ", localFile));
		return;
	break;
	case "contentP":
		return get("content");
	break;
	}
	usual();
}
\shownDepend {wwwSrc.list.sb}
\font {fixed}
\BGColor {LemonChiffon1}
\FGColor {black}
\verbatim {1}
\
